"use strict";
const Vue = require("vue");
const core = require("@vueuse/core");
const focusTrap = require("./focusTrap-Vbgxe8ZX.cjs");
function useTrapStackControl(shouldPause, options = {}) {
  const trapStackController = focusTrap.createTrapStackController();
  Vue.watch(shouldPause, () => {
    if (core.toValue(options.disabled)) {
      return;
    }
    if (core.toValue(shouldPause)) {
      trapStackController.pause();
    } else {
      trapStackController.unpause();
    }
  });
  Vue.onUnmounted(() => {
    trapStackController.unpause();
  });
}
exports.useTrapStackControl = useTrapStackControl;
//# sourceMappingURL=useTrapStackControl-BJmJdJak.cjs.map
