import { Ref } from 'vue';
import { MaybeRefOrGetter } from '@vueuse/core';
/**
 * Control global focus trap stack when focus trap is managed manually
 *
 * @param shouldPause - Whether focus trap should be paused
 * @param options - Additional options
 * @param options.disabled - Whether the controller should be disabled
 */
export declare function useTrapStackControl(shouldPause: Ref<boolean> | (() => boolean), options?: {
    disabled?: MaybeRefOrGetter<boolean>;
}): void;
