import { FocusTrap } from 'focus-trap';
declare global {
    interface Window {
        _nc_focus_trap: FocusTrap[];
    }
}
/**
 * Get the default global focus trap stack
 */
export declare function getTrapStack(): FocusTrap[];
/**
 * Create controller to pause/unpause the global focus trap stack.
 *
 * When some component manually implements its own focus-trap without using global focus-trap stack,
 * it also needs to pause the global stack to avoid conflict.
 */
export declare function createTrapStackController(): {
    /**
     * Pause the current focus-trap stack
     */
    pause(): void;
    /**
     * Unpause the paused focus trap stack
     */
    unpause(): void;
};
